"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("./util");
function createData(mongoModel) {
    var _this = this;
    return util_1.handleError(function (_a, res) {
        var body = _a.body;
        return __awaiter(_this, void 0, void 0, function () {
            var _id;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, mongoModel.create([body])];
                    case 1:
                        _id = (_b.sent())[0]._id;
                        res.status(200).json(__assign({}, _id, { body: body }));
                        return [2 /*return*/];
                }
            });
        });
    });
}
function getData(mongoModel) {
    var _this = this;
    return util_1.handleError(function (_a, res) { var _b, reqLimit, order, sortField, prevKey, nextKey, restQuery; return __awaiter(_this, void 0, void 0, function () {
        var query, limit, sortAscending, _c, previous, next, hasNext, results, hasPrevious;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    _b = _a.query, (reqLimit = _b.limit, order = _b.order, sortField = _b.sortField, prevKey = _b.previous, nextKey = _b.next, _b), restQuery = __rest(_b, ["limit", "order", "sortField", "previous", "next"]);
                    query = Object.entries(restQuery)
                        .map(function (_a) {
                        var _b;
                        var key = _a[0], value = _a[1];
                        return (_b = {},
                            _b[key] = { $in: Array.isArray(value) ? value : [value] },
                            _b);
                    })
                        .reduce(function (acc, val) { return (__assign({}, acc, val)); }, {});
                    limit = parseInt(reqLimit, undefined) || 10;
                    sortAscending = ("" + order).toLowerCase().startsWith("asc");
                    return [4 /*yield*/, mongoModel.paginate({
                            query: query,
                            limit: limit,
                            paginatedField: sortField,
                            sortAscending: sortAscending,
                            next: nextKey,
                            previous: prevKey
                        })];
                case 1:
                    _c = _d.sent(), previous = _c.previous, next = _c.next, hasNext = _c.hasNext, results = _c.results, hasPrevious = _c.hasPrevious;
                    res.status(200).json({
                        results: results,
                        limit: limit,
                        order: order,
                        sortField: sortField,
                        next: next,
                        hasNext: hasNext,
                        previous: previous,
                        hasPrevious: hasPrevious
                    });
                    return [2 /*return*/];
            }
        });
    }); });
}
function findDataByID(mongoModel) {
    var _this = this;
    return util_1.handleError(function (_a, res) {
        var _id = _a.params.id;
        return __awaiter(_this, void 0, void 0, function () {
            var data;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, mongoModel.findById(_id).lean()];
                    case 1:
                        data = _b.sent();
                        res.status(200).json(__assign({ _id: _id }, data));
                        return [2 /*return*/];
                }
            });
        });
    });
}
function updateDataByID(mongoModel) {
    var _this = this;
    return util_1.handleError(function (_a, res) {
        var body = _a.body, _id = _a.params.id;
        return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, mongoModel.updateOne({ _id: _id }, body).lean()];
                    case 1:
                        _b.sent();
                        res.status(200).json(__assign({ _id: _id }, body));
                        return [2 /*return*/];
                }
            });
        });
    });
}
/** Create a standard router that supports HTTP verbs using a mongodb model. */
function createStandardMongoDBRouter(router, _a) {
    var mongoModel = _a.mongoModel;
    router.get("", getData(mongoModel));
    router.post("", createData(mongoModel));
    router.get("/:id", findDataByID(mongoModel));
    router.patch("/:id", updateDataByID(mongoModel));
    return router;
}
exports.createStandardMongoDBRouter = createStandardMongoDBRouter;
